Index: /branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref
===================================================================
--- /branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref	(revision 5350)
+++ /branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref	(revision 5351)
@@ -380,8 +380,8 @@
 !                   * -2 => tracer concentration in sea ice is prescribed and 
 !                           trc_ice_prescr is used
-! trc_ice_prescr    * prescribed tracer concentration used only if 
-!                     trc_ice_ratio = -2, or -99. if not used
+! trc_ice_prescr    * prescribed tracer concentration. used only if 
+!                     trc_ice_ratio = -2. equals -99 if not used.
 ! cn_trc_o          * 'GL' use global ocean values making the Baltic distinction only
-!                     'AA' use Arctic/Antarctic contrast besides Baltic distinction
+!                     'AA' use specific Arctic/Antarctic/Baltic values
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
 !    sn_tri_ ! trc_ice_ratio ! trc_ice_prescr !     cn_trc_o
@@ -389,24 +389,24 @@
    sn_tri_doc =            0.,           -99.,          'AA'
    sn_tri_tal =           -1.,           -99.,          'AA'
-   sn_tri_oxy =           -1.,           -99.,          'GL'
-   sn_tri_cal =            0.,           -99.,          'GL'
+   sn_tri_oxy =           -1.,           -99.,          'AA'
+   sn_tri_cal =            0.,           -99.,          'AA'
    sn_tri_po4 =           -1.,           -99.,          'AA'
-   sn_tri_poc =            0.,           -99.,          'GL'
-   sn_tri_goc =            0.,           -99.,          'GL'
-   sn_tri_bfe =            0.,           -99.,          'GL'
-   sn_tri_num =            0.,           -99.,          'GL'
+   sn_tri_poc =            0.,           -99.,          'AA'
+   sn_tri_goc =            0.,           -99.,          'AA'
+   sn_tri_bfe =            0.,           -99.,          'AA'
+   sn_tri_num =            0.,           -99.,          'AA'
    sn_tri_sil =           -1.,           -99.,          'AA'
-   sn_tri_dsi =            0.,           -99.,          'GL'
-   sn_tri_gsi =            0.,           -99.,          'GL'
-   sn_tri_phy =            0.,           -99.,          'GL'
-   sn_tri_dia =            0.,           -99.,          'GL'
-   sn_tri_zoo =            0.,           -99.,          'GL'
-   sn_tri_mes =            0.,           -99.,          'GL'
+   sn_tri_dsi =            0.,           -99.,          'AA'
+   sn_tri_gsi =            0.,           -99.,          'AA'
+   sn_tri_phy =            0.,           -99.,          'AA'
+   sn_tri_dia =            0.,           -99.,          'AA'
+   sn_tri_zoo =            0.,           -99.,          'AA'
+   sn_tri_mes =            0.,           -99.,          'AA'
    sn_tri_fer =           -2.,          15E-9,          'AA'
-   sn_tri_sfe =            0.,           -99.,          'GL'
-   sn_tri_dfe =            0.,           -99.,          'GL'
-   sn_tri_nfe =            0.,           -99.,          'GL'
-   sn_tri_nch =            0.,           -99.,          'GL'
-   sn_tri_dch =            0.,           -99.,          'GL'
+   sn_tri_sfe =            0.,           -99.,          'AA'
+   sn_tri_dfe =            0.,           -99.,          'AA'
+   sn_tri_nfe =            0.,           -99.,          'AA'
+   sn_tri_nch =            0.,           -99.,          'AA'
+   sn_tri_dch =            0.,           -99.,          'AA'
    sn_tri_no3 =           -1.,           -99.,          'AA'
    sn_tri_nh4 =            1.,           -99.,          'AA'
Index: /branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_top_ref
===================================================================
--- /branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_top_ref	(revision 5350)
+++ /branches/2015/dev_r5171_CNRS_LIM3_seaicebgc/NEMOGCM/CONFIG/SHARED/namelist_top_ref	(revision 5351)
@@ -84,6 +84,6 @@
 !-----------------------------------------------------------------------
    nn_ice_tr   =  1        !  tracer concentration in sea ice 
-                           !    =-1 identical cc in ice and ocean (= old code)
-                           !    = 0 nil 
+                           !    =-1 (no vvl: identical cc in ice and ocean / vvl: cc_ice = 0)
+                           !    = 0 (no vvl: cc_ice = zero / vvl: cc_ice = )
                            !    = 1 prescribed to a namelist value (implemented in pisces only)
 /