Index: /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/ARCH/arch-macport_osx.fcm
===================================================================
--- /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/ARCH/arch-macport_osx.fcm	(revision 5352)
+++ /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/ARCH/arch-macport_osx.fcm	(revision 5353)
@@ -52,6 +52,5 @@
 %CPP	             cpp-mp-4.8
 %FC	             mpif90 
-###%FCFLAGS             -fdefault-real-8 -O3 -funroll-all-loops -fcray-pointer 
-%FCFLAGS             -fdefault-real-8 -O0 -g -fbacktrace -fbounds-check -funroll-all-loops -fcray-pointer 
+%FCFLAGS             -fdefault-real-8 -O3 -funroll-all-loops -fcray-pointer 
 %FFLAGS              %FCFLAGS
 %LD                  %FC
Index: /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/iodef.xml
===================================================================
--- /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/iodef.xml	(revision 5352)
+++ /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/iodef.xml	(revision 5353)
@@ -21,45 +21,7 @@
     -->
     
-    <file_definition type="one_file" name="@expname@_@freq@_@startdate@_@enddate@" sync_freq="10d" min_digits="4">
-    
-      <file_group id="1ts" output_freq="1ts"  output_level="10" enabled=".TRUE."> <!-- 1 time step files -->
-	
-	<file id="file11" name_suffix="_grid_T" description="ocean T grid variables" >
-	  <field_group  prec="8"  operation="instant" >
-	    <field field_ref="sst"          name="tos"      long_name="sea_surface_temperature"                       />
-	    <field field_ref="sss"          name="sos"      long_name="sea_surface_salinity"                          />
-	    <field field_ref="ssh"          name="zos"      long_name="sea_surface_height_above_geoid"                />
-	    <field field_ref="saltflx"      />
-	    <field field_ref="taum"         name="taum" />
-	    <field field_ref="wspd"         name="windsp"  />
-	    <field field_ref="precip"       name="precip" />
-	    <field field_ref="empmr"        name="wfo"      long_name="water_flux_into_sea_water"                     />
-	    <field field_ref="qsr"          name="rsntds"   long_name="surface_net_downward_shortwave_flux"           />
-	    <field field_ref="qt"           name="tohfls"   long_name="surface_net_downward_total_heat_flux"          />
-            <field field_ref="sst_m"  />
-            <field field_ref="sss_m"  />
-            <field field_ref="ssu_m"  />
-            <field field_ref="ssv_m"  />
-            <field field_ref="ssh_m"  />
-            <field field_ref="e3t_m"  />
-            <field field_ref="frq_m"  />
-            <field field_ref="qsr_oce"  />
-            <field field_ref="qsr_ice"  />
-            <field field_ref="qns_oce"  />
-            <field field_ref="qns_ice"  />
-            <field field_ref="sfxbri"  />
-            <field field_ref="sfxdyn"  />
-            <field field_ref="sfxres"  />
-            <field field_ref="sfxbog"  />
-            <field field_ref="sfxbom"  />
-            <field field_ref="sfxsum"  />
-            <field field_ref="sfxsni"  />
-            <field field_ref="sfxopw"  />
-            <field field_ref="sfx"  />
-
-	  </field_group>
-	</file>
-	
-      </file_group>
+    <file_definition type="multiple_file" name="@expname@_@freq@_@startdate@_@enddate@" sync_freq="10d" min_digits="4">
+    
+      <file_group id="1ts" output_freq="1ts"  output_level="10" enabled=".TRUE."/> <!-- 1 time step files -->
 
       <file_group id="1h" output_freq="1h"  output_level="10" enabled=".TRUE."/> <!-- 1h files -->
Index: /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_cfg
===================================================================
--- /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_cfg	(revision 5352)
+++ /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_cfg	(revision 5353)
@@ -6,7 +6,4 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   nn_it000    =       1   !  first time step
-   nn_itend    =     24    !  last  time step (std 5475)
-   ln_clobber  =  .true.   !  clobber (overwrite) an existing file
 /
 !-----------------------------------------------------------------------
@@ -31,5 +28,4 @@
 &namdom        !   space and time domain (bathymetry, mesh, timestep)
 !-----------------------------------------------------------------------
-   rn_rdt      = 3600.     !  time step for the dynamics (and tracer if nn_acc=0)
    jphgr_msh   =       0               !  type of horizontal mesh
    ppglam0     =  999999.0             !  longitude of first raw and column T-point (jphgr_msh = 1)
@@ -67,45 +63,4 @@
 &namsbc        !   Surface Boundary Condition (surface module)
 !-----------------------------------------------------------------------
-   nn_fsbc     = 1         !  frequency of surface boundary condition computation
-                           !     (also = the frequency of sea-ice model call)
-   ln_ana      = .false.   !  analytical formulation                    (T => fill namsbc_ana )
-   ln_flx      = .false.   !  flux formulation                          (T => fill namsbc_flx )
-   ln_blk_clio = .false.   !  CLIO bulk formulation                     (T => fill namsbc_clio)
-   ln_blk_core = .true.    !  CORE bulk formulation                     (T => fill namsbc_core)
-   ln_blk_mfs  = .false.   !  MFS bulk formulation                      (T => fill namsbc_mfs )
-   ln_cpl      = .false.   !  atmosphere coupled   formulation          ( requires key_oasis3 )
-   ln_mixcpl   = .false.   !  forced-coupled mixed formulation          ( requires key_oasis3 )
-   nn_components = 0       !  configuration of the opa-sas OASIS coupling
-                           !  =0 no opa-sas OASIS coupling: default single executable configuration
-                           !  =1 opa-sas OASIS coupling: multi executable configuration, OPA component
-                           !  =2 opa-sas OASIS coupling: multi executable configuration, SAS component 
-   ln_apr_dyn  = .false.   !  Patm gradient added in ocean & ice Eqs.   (T => fill namsbc_apr )
-   nn_ice      = 2         !  =0 no ice boundary condition   ,
-                           !  =1 use observed ice-cover      ,
-                           !  =2 ice-model used                         ("key_lim3" or "key_lim2")
-   nn_ice_embd = 1         !  =0 levitating ice (no mass exchange, concentration/dilution effect)
-                           !  =1 levitating ice with mass and salt exchange but no presure effect
-                           !  =2 embedded sea-ice (full salt and mass exchanges and pressure)
-   ln_dm2dc    = .false.   !  daily mean to diurnal cycle on short wave
-   ln_rnf      = .false.   !  runoffs                                   (T   => fill namsbc_rnf)
-   nn_isf      = 0         !  ice shelf melting/freezing                (/=0 => fill namsbc_isf)
-                           !  0 =no isf                  1 = presence of ISF 
-                           !  2 = bg03 parametrisation   3 = rnf file for isf   
-                           !  4 = ISF fwf specified
-                           !  option 1 and 4 need ln_isfcav = .true. (domzgr)
-   ln_ssr      = .flase.   !  Sea Surface Restoring on T and/or S       (T => fill namsbc_ssr)
-   nn_fwb      = 2         !  FreshWater Budget: =0 unchecked
-                           !     =1 global mean of e-p-r set to zero at each time step
-                           !     =2 annual global mean of e-p-r set to zero
-   ln_wave = .false.       !  Activate coupling with wave (either Stokes Drift or Drag coefficient, or both)  (T => fill namsbc_wave)
-   ln_cdgw = .false.       !  Neutral drag coefficient read from wave model (T => fill namsbc_wave)
-   ln_sdw  = .false.       !  Computation of 3D stokes drift                (T => fill namsbc_wave)
-   nn_lsm  = 0             !  =0 land/sea mask for input fields is not applied (keep empty land/sea mask filename field) ,
-                           !  =1:n number of iterations of land/sea mask application for input fields (fill land/sea mask filename field)
-   nn_limflx = -1          !  LIM3 Multi-category heat flux formulation (use -1 if LIM3 is not used)
-                           !  =-1  Use per-category fluxes, bypass redistributor, forced mode only, not yet implemented coupled
-                           !  = 0  Average per-category fluxes (forced and coupled mode)
-                           !  = 1  Average and redistribute per-category fluxes, forced mode only, not yet implemented coupled
-                           !  = 2  Redistribute a single flux over categories (coupled mode only)
 /
 !-----------------------------------------------------------------------
@@ -116,5 +71,4 @@
 &namtra_qsr    !   penetrative solar radiation
 !-----------------------------------------------------------------------
-   ln_qsr_ice  = .true.    !  light penetration for ice-model LIM3
 /
 !-----------------------------------------------------------------------
@@ -157,5 +111,4 @@
 &nameos        !   ocean physical parameters
 !-----------------------------------------------------------------------
-   ln_useCT    = .false.  ! use of Conservative Temp. ==> surface CT converted in Pot. Temp. in sbcssm
 /
 !-----------------------------------------------------------------------
@@ -174,9 +127,4 @@
 &namtra_dmp    !   tracer: T & S newtonian damping
 !-----------------------------------------------------------------------
-   ln_tradmp   =  .false.  !  add a damping termn (T) or not (F)
-   nn_zdmp     =    0      !  vertical   shape =0    damping throughout the water column
-                           !                   =1 no damping in the mixing layer (kz  criteria)
-                           !                   =2 no damping in the mixed  layer (rho crieria)
-   cn_resto    = 'resto.nc' ! Name of file containing restoration coefficient field (use dmp_tools to create this)
 /
 !-----------------------------------------------------------------------
@@ -197,5 +145,5 @@
    ln_hpg_prj  = .true.    !  s-coordinate (Pressure Jacobian scheme)
    ln_dynhpg_imp = .false. !  time stepping: semi-implicit time scheme  (T)
-                           !           centered      time scheme  (F)
+                                 !           centered      time scheme  (F)
 /
 !-----------------------------------------------------------------------
Index: /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_ice_cfg
===================================================================
--- /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_ice_cfg	(revision 5352)
+++ /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/namelist_ice_cfg	(revision 5353)
@@ -10,5 +10,4 @@
 &namiceini     !   ice initialisation
 !-----------------------------------------------------------------------
-   ln_iceini      = .true.         !  activate ice initialization (T) or not (F)
 /
 !-----------------------------------------------------------------------
Index: /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/cpp_ORCA2_LIM3.fcm
===================================================================
--- /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/cpp_ORCA2_LIM3.fcm	(revision 5352)
+++ /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/ORCA2_LIM3/cpp_ORCA2_LIM3.fcm	(revision 5353)
@@ -1,1 +1,1 @@
- bld::tool::fppkeys key_trabbl key_lim3 key_vvl key_dynspg_ts key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi key_diaobs key_asminc key_nosignedzero
+ bld::tool::fppkeys key_trabbl key_lim3 key_vvl key_dynspg_ts key_diaeiv key_ldfslp key_traldf_c2d key_traldf_eiv key_dynldf_c3d key_zdftke key_zdfddm key_zdftmx key_iomput key_mpp_mpi key_diaobs key_asminc
Index: /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/cfg.txt
===================================================================
--- /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/cfg.txt	(revision 5352)
+++ /branches/2015/dev_r5218_CNRS17_coupling/NEMOGCM/CONFIG/cfg.txt	(revision 5353)
@@ -10,5 +10,4 @@
 ISOMIP OPA_SRC
 GYRE OPA_SRC
+ORCA2_LIM3 OPA_SRC LIM_SRC_3 NST_SRC
 ORCA2_LIM OPA_SRC LIM_SRC_2 NST_SRC
-ORCA2_LIM3 OPA_SRC LIM_SRC_3 NST_SRC
-ORCA2_SAS_LIM3 OPA_SRC SAS_SRC LIM_SRC_3 NST_SRC